<?php

elgg_register_event_handler('init', 'system', 'facebookKpax_init');

function facebookKpax_init() {
	$root = dirname(__FILE__);

	// Libraries
	elgg_register_library('elgg:facebook', "$root/vendors/facebook/facebook.php");
	elgg_register_library('elgg:facebookKpax', "$root/lib/facebookKpax.php");

	elgg_load_library('elgg:facebook');
	elgg_load_library('elgg:facebookKpax');

	// View
	elgg_extend_view('forms/login', 'facebookKpax/login');


	// Page handler
	elgg_register_page_handler('facebookKpax', 'facebookKpax_page_handler');

	// Exposed function for kPAX core Facebook validation.
	function fbk_sign($username="") {

	        $credentials = array('username' => $username);

	        $user = get_user_by_username($credentials['username']);
	        if (!empty($user) && facebookKpax_is_facebook_user($credentials['username'])) {
	            return "OK";
	        } else {
	            return "ERROR";
	        }
	}

	expose_function("fbk.sign", "fbk_sign", array("username" => array('type' => 'String', 'required' => true)), 'Auth sign facebook', 'GET', true, false);

}


/**
 * Page handler for facebookKpax.
 *
 * If login page requested, calls facebookKpax_login function.
 *
 * @param array $page
 */

function facebookKpax_page_handler($page) {
	global $CONFIG;
	if (!isset($page[0])) {
		forward();
	}
	$_GET['session'] = $CONFIG->input['session'];

	if ($page[0] == 'login') {
		facebookKpax_login();
	} else {
		forward();
	}
}

	
